<!--
  -   Copyright 2014-2023 IHE International
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<ui:composition xmlns:rich="http://richfaces.org/rich" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:g="http://www.ihe.net/gazelle"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalForm">
            <h2>#{messages['net.ihe.gazelle.audit.message.AuditMessages']}</h2>

            <h:panelGroup rendered="#{s:hasRole('admin_role') || s:hasRole('tests_editor_role')}">
                <p>
                    <h:outputLink value="#{auditMessageList.linkToCreateAuditMessage()}" styleClass="gzl-btn">
                        #{messages['net.ihe.gazelle.audit.message.CreateIHEAuditMessageDescription']}
                    </h:outputLink>
                    <a4j:commandButton value="#{messages['net.ihe.gazelle.audit.message.ImportSpecification_2']}"
                                       oncomplete="jq162('#upload_specification').modal('show')" execute="@this"
                                       render="upload_specification_div" styleClass="gzl-btn" type="button"/>
                    <a4j:commandButton value="#{messages['net.ihe.gazelle.audit.message.ImportSpecificationArchive']}"
                                       oncomplete="jq162('#upload_specification_archive').modal('show')" execute="@this"
                                       render="upload_specification_div" styleClass="gzl-btn" type="button"/>
                </p>
            </h:panelGroup>

            <s:div id="mainDiv">
                <p>
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.audit.message.NumberOfAuditMessageSpecification']} #{auditMessageList.getListAuditMessageSpecifications().size()}"/>
                </p>
                #{dataTableStateHolder.setAscendingOn('name')}
                <rich:dataTable id="amsTable" value="#{auditMessageList.getAmsDataModel()}" var="ams"
                                rows="#{dataScrollerMemory.numberOfResultsPerPage}" render="amsDS">
                    <g:column sortBy="#{'oid'}" sortOrder="#{dataTableStateHolder.sortOrders['oid']}"
                              filterBy="#{'oid'}">
                        <ui:define name="header">#{messages['net.ihe.gazelle.audit.message.OID']}</ui:define>
                        <g:link value="#{ams}" target="_blank"/>
                    </g:column>
                    <g:column sortBy="#{'name'}" sortOrder="#{dataTableStateHolder.sortOrders['name']}"
                              filterBy="#{'name'}">
                        <ui:define name="header">#{messages['net.ihe.gazelle.audit.message.Name']}</ui:define>
                        <h:outputText value="#{ams.name}"/>
                    </g:column>
                    <g:column sortBy="#{'document'}" sortOrder="#{dataTableStateHolder.sortOrders['document']}"
                              filterBy="#{'document'}">
                        <ui:define name="header">#{messages['net.ihe.gazelle.audit.message.Document']}</ui:define>
                        <h:outputText value="#{ams.document}"/>
                    </g:column>
                    <g:column sortBy="#{'section'}" sortOrder="#{dataTableStateHolder.sortOrders['section']}"
                              filterBy="#{'section'}">
                        <ui:define name="header">#{messages['net.ihe.gazelle.audit.message.Section']}</ui:define>
                        <h:outputText value="#{ams.section}"/>
                    </g:column>
                    <g:column sortBy="#{'lastChanged'}"
                              sortOrder="#{dataTableStateHolder.sortOrders['lastChanged']}"
                              filterBy="#{'lastChanged'}">
                        <ui:define name="header">#{messages['net.ihe.gazelle.audit.message.LastChange']}</ui:define>
                        <g:date value="#{ams.lastChanged}"/>
                        <h:outputText value=" #{messages['net.ihe.gazelle.audit.message.By']} #{auditMessageList.getUserName(ams.lastModifierId)}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">
                            <h:outputText value="#{messages['net.ihe.gazelle.audit.message.Action_2']}"/>
                            <h:panelGroup rendered="#{s:hasRole('admin_role') || s:hasRole('tests_editor_role')}">
                                <h:commandLink action="#{auditMessageList.downloadAll()}" target="_blank"
                                               title="#{messages['net.ihe.gazelle.audit.message.DownloadAll']}">
                                    <span class="fa fa-file-code-o"></span>
                                </h:commandLink>
                                <h:outputLink onclick="jq162('#confirm_delete_all').modal('show')"
                                              title="#{messages['net.ihe.gazelle.audit.message.DeleteAllSpecifications']}"
                                              value="#"
                                              styleClass="text-danger">
                                    <span class="fa fa-trash-o"></span>
                                </h:outputLink>
                            </h:panelGroup>
                        </ui:define>
                        <div class="gzl-never-wrap">
                            <h:outputLink value="#{auditMessageList.linkToViewAuditMessage(ams)}"
                                          title="#{messages['net.ihe.gazelle.audit.message.View']}">
                                <s:span styleClass="fa fa-search"></s:span>
                            </h:outputLink>
                            <h:panelGroup rendered="#{s:hasRole('admin_role') || s:hasRole('tests_editor_role')}">
                                <h:commandLink action="#{auditMessageList.exportToXml(ams)}"
                                               title="#{messages['net.ihe.gazelle.audit.message.ExportToXML']}">
                                    <span class="fa fa-file-code-o"></span>
                                </h:commandLink>
                                <h:outputLink value="#{auditMessageList.editSelectedAuditMessageSpecification(ams)}"
                                              title="#{messages['net.ihe.gazelle.audit.message.Edit']}">
                                    <span class="fa fa-pencil"></span>
                                </h:outputLink>
                                <a4j:commandLink action="#{auditMessageList.copyAuditMessage(ams)}" render="mainDiv"
                                                 title="#{messages['net.ihe.gazelle.audit.message.Copy']}">
                                    <span class="fa fa-files-o"></span>
                                </a4j:commandLink>
                                <a4j:commandLink action="#{auditMessageList.setSelectedAuditMessageSpecification(ams)}"
                                                 oncomplete="jq162('#confirm_delete').modal('show')"
                                                 title="#{messages['net.ihe.gazelle.audit.message.Remove']}"
                                                 styleClass="text-danger">
                                    <span class="fa fa-trash-o"></span>
                                </a4j:commandLink>
                            </h:panelGroup>
                        </div>
                    </g:column>
                    <f:facet name="footer">
                        <ui:include src="/util/datatableFooter.xhtml">
                            <ui:param name="dataScrollerId" value="amsDS"/>
                            <ui:param name="dataTableId" value="amsTable"/>
                        </ui:include>
                    </f:facet>
                </rich:dataTable>
            </s:div>

        </h:form>

        <h:panelGroup rendered="#{s:hasRole('admin_role') || s:hasRole('tests_editor_role')}">

            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="confirm_delete"/>
                <ui:define name="popup_title"><span class="fa fa-exclamation-triangle"></span>#{messages['net.ihe.gazelle.audit.message.Warning']}
                </ui:define>
                <p>#{messages['net.ihe.gazelle.audit.message.YouAreAboutToDeleteTheAuditMessageSpecificationT']}</p>
                <ui:define name="popup_footer">
                    <h:form>
                        <button type="button" class="gzl-btn" data-dismiss="modal">
                            #{messages['net.ihe.gazelle.atna.Cancel']}
                        </button>
                        <a4j:commandButton action="#{auditMessageList.deleteSelectedAuditMessageSpecification()}"
                                           oncomplete="jq162('#confirm_delete').modal('hide')" execute="@this"
                                           value="#{messages['net.ihe.gazelle.atna.Delete']}"
                                           render="globalForm,gazelle-messages"
                                           styleClass="gzl-btn-red">
                        </a4j:commandButton>
                    </h:form>
                </ui:define>
            </ui:decorate>

            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="confirm_delete_all"/>
                <ui:define name="popup_title"><span class="fa fa-exclamation-triangle"></span>#{messages['net.ihe.gazelle.audit.message.Warning']}
                </ui:define>
                <p>#{messages['net.ihe.gazelle.audit.message.YouAreAboutToDeleteALLAuditMessageSpecifications']}</p>
                <ui:define name="popup_footer">
                    <h:form>
                        <button type="button" class="gzl-btn" data-dismiss="modal">
                            #{messages['net.ihe.gazelle.atna.Cancel']}
                        </button>
                        <a4j:commandButton action="#{auditMessageList.deleteAllSpecifications()}"
                                           oncomplete="jq162('#confirm_delete_all').modal('hide')" execute="@this"
                                           value="#{messages['net.ihe.gazelle.atna.Delete']}"
                                           render="globalForm,gazelle-messages"
                                           styleClass="gzl-btn-red">
                        </a4j:commandButton>
                    </h:form>
                </ui:define>
            </ui:decorate>

            <h:form id="importSpecForm">
                <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                    <ui:param name="popup_id" value="upload_specification"/>
                    <ui:define name="popup_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.audit.message.UploadSpecification']}"/>
                    </ui:define>

                    <s:div id="upload_specification_div">
                        <s:decorate template="/layout/form/_edit.xhtml">
                            <ui:param name="id" value="amsInput"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.audit.message.XMLAuditMessageSpecificationFile']}
                            </ui:define>

                            <rich:fileUpload id="amsInput"
                                             fileUploadListener="#{auditMessageList.uploadAmsListener}"
                                             maxFilesQuantity="1"
                                             acceptedTypes="xml" listHeight="60px"
                                             immediateUpload="true"
                                             required="tue"/>
                        </s:decorate>
                    </s:div>

                    <ui:define name="popup_footer">
                        <button type="button" class="gzl-btn" data-dismiss="modal">
                            #{messages['net.ihe.gazelle.atna.Cancel']}
                        </button>
                        <h:commandButton action="#{auditMessageList.importSpecification()}"
                                         onclick="jq162('#upload_specification').modal('hide');gazelleStatusStart();"
                                         value="#{messages['net.ihe.gazelle.audit.message.Confirm']}"
                                         styleClass="gzl-btn-blue"/>
                    </ui:define>
                </ui:decorate>
            </h:form>

            <h:form>
                <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                    <ui:param name="popup_id" value="upload_specification_archive"/>
                    <ui:define name="popup_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.audit.message.UploadSpecificationArchive']}"/>
                    </ui:define>

                    <s:div id="upload_specification_archive_div">
                        <s:decorate template="/layout/form/_edit.xhtml">
                            <ui:param name="id" value="amsArchInput"/>
                            <ui:define name="label">
                                #{messages['net.ihe.gazelle.audit.message.ZIPAuditMessageSpecificationArchive']}
                            </ui:define>
                            <rich:fileUpload id="amsArchInput"
                                             fileUploadListener="#{auditMessageList.uploadAmsArchiveListener}"
                                             maxFilesQuantity="1"
                                             acceptedTypes="zip" listHeight="60px"
                                             immediateUpload="true"
                                             required="tue"/>
                        </s:decorate>
                    </s:div>

                    <ui:define name="popup_footer">
                        <button type="button" class="gzl-btn" data-dismiss="modal">
                            #{messages['net.ihe.gazelle.atna.Cancel']}
                        </button>
                        <h:commandButton action="#{auditMessageList.importSpecificationArchive()}"
                                         onclick="jq162('#upload_specification_archive').modal('hide');gazelleStatusStart();"
                                         value="#{messages['net.ihe.gazelle.audit.message.Confirm']}"
                                         styleClass="gzl-btn-blue"/>
                    </ui:define>
                </ui:decorate>
            </h:form>

        </h:panelGroup>
    </ui:define>
</ui:composition>
